/**
_킷NXłB
_FarmHand(_J)C^[tFCXNX(ƂΖOjbgȂ)ɂč쐬̌z(Structure)łB

plantTimeMonthϐɂĒ߂ꂽɁAFarmHandC^[tFCXNX́AFarmIuWFNgɑ΂Ď܂ȂƂł܂B(plant(FarmHand)\bh)

̐́A̔_J҃jbg̏L̐(FarmHand.getSeeds()\bh)ƁA̓c̖ʐς킷seedsAreaϐɂČ肳܂B
̓cɌ݂܂Ă̐seedsϐɂĂ킳܂B

n(harvestCrops)ƁAseeds̐lĂ䂭ƓharvestCrops̐lĂ܂B̓Iɂseeds1邲ƂɁAharvestCropsfertilityӂĂ䂫܂B
*/
package tk.mtantyukityuki.threeKingdoms.unit;

import tk.mtantyukityuki.threeKingdoms.model.*;
import tk.mtantyukityuki.threeKingdoms.unit.controller.*;
import tk.mtantyukityuki.threeKingdoms.unit.graphicsEngine.*;

import java.awt.*;

public class Farm extends Structure implements RunnableUnit {


	public Farm(int x, int y, Board board, int seedsArea, int nationality) {
		super(x, y, board, new Direction(Direction.UP), nationality);

		this.seedsArea = seedsArea;

		init();
	}

	public void init() {
		name = "_n";
		fertility = 50;
		harvestTimeMonth = 6;
		plantTimeMonth = 10;
	}


	/** yn̖LB(\zn)*/
	//int crop Estimate;

	/** 엀xBꂽЂƂɂA邩킷lBɂFarm𔞔Ɛݒ肷̂ȂA50`150BcƐݒ肷̂Ȃ1000`2000炢B */
	int fertility;

	/** ̔_n̖ʐρB(̎܂Ƃł邩) */
	int seedsArea;

	/** nB*/
	int harvestTimeMonth;

	/** tB*/
	int plantTimeMonth;


	/** ꂽ̐B*/
	int seeds;
	/** ̐B*/
	int harvestCrops;

	/** GQȂǂ̍̈琬܂̂킷f[^B*/
	int weeds;


	/** FarmHand(_J)C^[tFCXjbgɂāAFarmIuWFNgɍ앨A܂B*/
	public void plant(FarmHand farmHand) {

		// ܂t\ȋG߂łȂȂAȂɂIB
		if (plantTimeMonth != Time.getInstance().getMonth()) {
			return;
		}

		// ܂t\ȋG߂ȂtJnB
		synchronized(farmHand) {

			// ܂łlƁAJ҂̎̐͂ǂ炪B
			if (farmHand.getFarmPower() < farmHand.getSeeds()) {

				// ܂łlƁA̔_n̖ʐ(̐)͂ǂ炪B
				if (farmHand.getFarmPower() < (seedsArea - seeds)) {
					// _J҂̐l̕A̔_nɎ܂B
					farmHand.subSeeds(farmHand.getFarmPower());
					seeds += farmHand.getFarmPower();
				}
				else {
					// ̔_n̖ʐςׂ̎Ă܂Ă܂B
					farmHand.subSeeds((seedsArea - seeds));
					seeds = seedsArea;
				}
			}
			else {

				// J҂̎̐ƁA̔_n̖ʐ(̐)͂ǂ炪B
				if (farmHand.getSeeds() < (seedsArea - seeds)) {
					// _J҂̏LׂāA̔_nɂ܂B
					seeds += farmHand.getSeeds();
					farmHand.setSeeds(0);
				}
				else {
					// ̔_n̖ʐςׂ̎Ă܂Ă܂B
					farmHand.subSeeds((seedsArea - seeds));
					seeds = seedsArea;
				}
			}
		}
	}

	/** FarmHand(_J)C^[tFCXjbgɂāAFarmIuWFNgŎ앨n܂B*/
	public int harvest(FarmHand farmHand) {

		int retHarvestCrops = harvestCrops;

		if (farmHand.getFarmPower() < harvestCrops) {
			retHarvestCrops = farmHand.getFarmPower();
			harvestCrops -= retHarvestCrops;
			farmHand.addCrops(retHarvestCrops);
		}
		else {
			retHarvestCrops = harvestCrops;
			harvestCrops = 0;
			farmHand.addCrops(retHarvestCrops);
		}

		return retHarvestCrops;
	}

	/** OjbgɂČĂяo郁\bhłBFarmIuWFNgG𔲂Q쏜肵܂B*/
	public void weed(FarmHand farmHand) {
		weeds -= farmHand.getFarmPower();
		if ( 0 > weeds ) {
			weeds = 0;
		}
	}


	public int getOffensivePower(Direction attackedDirection) {
		return 2;
	}
	public int getDefensivePower(Direction attackedDirection) {
		return 2;
	}

	public void show(Graphics g, int x, int y, UnitGraphicsEngine uge,
											Component view, Direction direction) {
		uge.show(g, x,y, this, view, direction);
	}


	public void run() {

		// ܂鎞ȂA点B
		if (harvestTimeMonth == Time.getInstance().getMonth()) {
			// harvestSeeds ͍run()Ŏ点̐킷ϐB
			int harvestSeeds = (int)( (seeds + 1) * Math.random() );
			harvestCrops += harvestSeeds * fertility;
			seeds -= harvestSeeds;
		}

		// QGȂǂ킷 weeds ̒lƂɁA
		// ꂽB
		int lostSeeds = (int)(weeds * Math.random());

		seeds -= lostSeeds;
		if (0 > seeds) {
			seeds = 0;
		}

		harvestCrops -= lostSeeds * fertility;
		if (0 > harvestCrops) {
			harvestCrops = 0;
		}

		// GQ1₷B
		seeds++;
	};
}

