/**
Xт킷NXB
*/
package tk.mtantyukityuki.threeKingdoms.unit;

import tk.mtantyukityuki.threeKingdoms.model.*;
import tk.mtantyukityuki.threeKingdoms.unit.controller.*;
import tk.mtantyukityuki.threeKingdoms.unit.graphicsEngine.*;

import java.awt.*;

public class Forest extends Structure implements RunnableUnit {

	/** ؂̖{B*/
	int trees;

	/** ؂̔NB*/
	int age;

	/** ؂ݐǂ킷tB[hłB*/
	boolean isGrown;


	public Forest(int x, int y, Board board, int trees, int age) {
		super(x, y, board, new Direction(Direction.UP), 0);

		this.trees = trees;
		this.age = age;

		init();
	}

	public void init() {
		name = "X";
	}


	public int getAge() { return age; }

	public int getOffensivePower(Direction attackedDirection) {
		return 4;
	}
	public int getDefensivePower(Direction attackedDirection) {
		return 4;
	}

	public void show(Graphics g, int x, int y, UnitGraphicsEngine uge,
											Component view, Direction direction) {
		uge.show(g, x,y, this, view, direction);
	}


	public void run() {
		// Ƃ肠7ɖ؂𐬒Ă݂B
		if (7 == Time.getInstance().getMonth() && !isGrown) {
			age++;
			isGrown = true;
		} else if (8 == Time.getInstance().getMonth()) {
			isGrown = false;
		}
	};
}

