/** mЂƂЂƂÄ{{ɂ܂ŃXbhӂ̂́AȂɂƁA߂ǂB
ŎԂƂƂɂ肩郆jbǵAׂāARunnableXgNX̃XbhЂƂĈꌳIɊǗB */
package tk.mtantyukityuki.threeKingdoms.unit;

import tk.mtantyukityuki.threeKingdoms.model.*;
import tk.mtantyukityuki.threeKingdoms.unit.graphicsEngine.*;

import java.awt.*;

public class RunnableUnitList implements Runnable {

	Thread unitThread = null;
	Time time;	// RunnableUnitListǗTimeNXB

	RunnableUnitNode last;	// Ō̗vfB
	int length;	// vfB

	public RunnableUnitList(Time time) {
		this.time = time;
		last = null;
		length = 0;
	}
	public RunnableUnitList(RunnableUnit u, Time time) {
		this.time = time;
		last = null;
		length = 0;
		add(u);
	}

	public void start() {
		while (unitThread == null) {
			unitThread = new Thread(this);
		}
		time.addRunnableUnitList( this );
		unitThread.start();
	}

	public void show(Graphics g, int squareSizeX, int squareSizeY, UnitGraphicsEngine uge, Component viewer, Direction direction) {

		if (last != null) {
			RunnableUnitNode nUnit = last;


			// XgɂԂ炳Ăŏ̗vfAŌ̗vf܂ŁAԂshowĂяoB
			do {
				if( nUnit.next.item != null ) {
					nUnit.next.item.show(g, squareSizeX, squareSizeY, uge, viewer, direction);

					nUnit = nUnit.next;
				} else {
				// m[h烆jbgłĂ烊Xg폜B

					length--;
					// ݁AXgɂvfȂA폜ƃXgɂȂ̂ȂAXglastnullB
					if (nUnit.next == nUnit.next.next) {
						last = null;
						nUnit.next = null;	//ȎQƂ߂邱ƂŃK[xbWRNVɎg폜B
						nUnit = nUnit.next;
					} else {
						// 폜vfXg̍Œ[̗vfȂAlast̎wCB
						if (nUnit.next == last)
							last = nUnit;
						nUnit.next = nUnit.next.next;
					}
				}


			} while (nUnit != last);
		}
	}

	public void run() {

		while ( !time.isStop() ) {

			if (last != null) {

				RunnableUnitNode nUnit = last;

				// XgɂԂ炳Ăŏ̗vfAŌ̗vf܂ŁA
				// ԂrunĂяoB
				do {
					if( nUnit.next.item != null ) {
						nUnit.next.item.run();
						nUnit = nUnit.next;
					}
					else {
						// m[h烆jbgłĂ烊Xg폜B
						length--;

						// ݁AXgɂvfȂA
						// 폜ƃXgɂȂ̂ȂA
						// XglastnullB
						if (nUnit.next == nUnit.next.next) {
							last = null;
							nUnit.next = null;	//ȎQƂ߂邱ƂŃK[xbWRNVɎg폜B
							nUnit = nUnit.next;
						} else {
							// 폜vfXg̍Œ[̗vfȂAlast̎wCB
							if (nUnit.next == last)
								last = nUnit;
							nUnit.next = nUnit.next.next;
						}
					}

				} while (nUnit != last && !time.isStop() );
			}
			// EGCgB
			time.waitRunnableUnitList();
			unitThread.yield();
		}
		time.removeRunnableUnitList( this );
		unitThread = null;
	}

	public void allRemove() {
		if (last != null)
			last.next = null;
		last = null;
		length = 0;
	}

	/** ɂĎw肳ꂽvf폜郁\bhB(m[h͂̂܂)
	 *폜Ƃ́Anull邾ł́A邪B
	 *Ԓl:trueBw肳ꂽvf𖳎폜łƂB
	 *Ԓl:falseBw肳ꂽvfXgɑ݂ȂȂǁAȂ炩̗Rō폜łȂƂB
	*/
	public boolean remove(RunnableUnit funit) {

		if (last != null) {

			RunnableUnitNode node_check = last;

			do {

				// Ãm[hԂ炳ĂvfAw̗vfꍇ͍폜trueԂB
				if (node_check.next.item == funit) {

					node_check.next.item = null;
					return true;
				}
				node_check = node_check.next;

			} while(node_check != last);
		}

		// XgɁAw肳ꂽvfȂꍇfalseԂďIB
		return false;
	}


	/** ɂĎw肳ꂽvfm[hƍ폜郁\bhB
	 *Ԓl:trueBw肳ꂽvf𖳎폜łƂB
	 *Ԓl:falseBw肳ꂽvfXgɑ݂ȂȂǁAȂ炩̗Rō폜łȂƂB
	*/
	public boolean removeNodeAndUnit(RunnableUnit funit) {

		if (last != null) {

			RunnableUnitNode node_check = last;

			do {

				// Ãm[hԂ炳ĂvfAw̗vfꍇ͍폜trueԂB
				if (node_check.next.item == funit) {

					// ݃XgɂvfȂA폜ƃXgɂȂ̂ȂAXglastnullB
					if (node_check.next == node_check.next.next) {
						last = null;
						node_check.next = null;	//ȎQƂ߂邱ƂŃK[xbWRNVɎg폜B
						length = 0;
					} else {
						if (node_check.next == last)
							last = node_check;
						node_check.next = node_check.next.next;
						// 폜vfXg̍Œ[̗vfȂAlast̎wCB
					length--;
					}
					return true;
				}
				node_check = node_check.next;

			} while(node_check != last);
		}

		// XgɁAw肳ꂽvfȂꍇfalseԂďIB
		return false;
	}


	/** Xg̍ŌɗvfǉB */
	public void add(RunnableUnit funit) {

		RunnableUnitNode node_newUnit = new RunnableUnitNode(funit);

		if (last != null) {
			node_newUnit.next = last.next;
			last.next = node_newUnit;
		} else
			node_newUnit.next = node_newUnit;

		last = node_newUnit;
		length++;

	}

	/** ŏ琔iԖڂ̗vfԂB */
	public RunnableUnit get(int i) {
		RunnableUnitNode retUnitNode;

		if (0 > i || i >= length)
			return null;
		else {
			retUnitNode = last.next;
			for (; i != 0; i--)
				retUnitNode = retUnitNode.next;

			return retUnitNode.item;
		}
	}

	public int getLength() { return length; }

	class RunnableUnitNode {

		RunnableUnitNode next;
		RunnableUnit item;

		public RunnableUnitNode(RunnableUnit rUnit) {
			item = rUnit;
		}
	}

}
