/** mNXAnhNXAnNXARNXANX
Ȃǂ̔Տ(boardNX)ɂ邷ׂẴIuWFNg̐eNX */
package tk.mtantyukityuki.threeKingdoms.unit;

import tk.mtantyukityuki.threeKingdoms.model.*;
import tk.mtantyukityuki.threeKingdoms.unit.controller.*;
import tk.mtantyukityuki.threeKingdoms.unit.graphicsEngine.*;

import java.awt.*;
import java.util.*;


public abstract class Unit {

	String name;	//IuWFNg̖OB
	int x;	//̃jbgBoard̂ǂ̈ʒuɐݒu邩B
	int y;
	Board board; //̃jbgzuՁB

	int weight;	//̃jbg̏dʁB
	int hp;		//qbg|CgB[ɂȂƁÃjbg͏łB
	int maxHP = 100;	//̃NX̍őqbg|CgB

	int nationality;	// GEʂBȂ瓯B邢͖jbg̒l0B
	Direction direction;	//̃jbgA܂ǂ̕Ă邩B

	UnitGraphicsEngine uge = UnitGraphicsEngineApplicationQuarter.getInstance();


	// MVC邽߂̃oϐB

	/** ݁AXi[ɕύXʒmł邩ǂۑϐłB*/
	boolean notifying;

	/**
	 * UnitCX^XABoardړƂqbg|CgȂǁAȂɂύXƂA
	 * ̕ύXm点Ȃ΂ȂȂXi[ۑĂϐłB
	 */
	Vector listeners = new Vector();


	public Unit(int x, int y, Board board, Direction direction, int nationality) {
		this.x = x;
		this.y = y;
		this.board = board;
		this.direction = direction;
		this.nationality = nationality;
	}

	public int getX() { return x; }
	public void setX( int x ) { this.x = x; }
	public int getY() { return y; }
	public void setY( int y ) { this.y = y; }
	public void setHp( int hp ) { this.hp = hp; }
	public int getHp() { return hp; }
	public int getMaxHp() { return maxHP; }
	public int getNationality() { return nationality; }
	public Direction getDirection() { return direction; }
	public String getName() { return name; }

	public void setDirection(int direction) {
		if (this.direction == null) {
			this.direction = new Direction(direction);
		}
		else {
			this.direction.setDirection(direction);
		}
	}

	public void setDirection(Direction direction) {
		if (this.direction == null) {
			this.direction = new Direction(direction);
		}
		else {
			this.direction.setDirection(direction);
		}
	}


	public void addUnitListener( UnitListener unitListener ) {
		listeners.add( unitListener );
	}

	public void removeUnitListener( UnitListener unitListener ) {
		listeners.remove( unitListener );
	}

	public boolean isNotifying() { return notifying; }
	public void setNotifying(boolean notifying) { this.notifying = notifying; }


	public void show(Graphics g, int x, int y, UnitGraphicsEngine uge, Component view, Direction direction) {
		uge.show(g, x,y, this, view, direction);
	}
	/** w肳ꂽWAunit̋Eɂ邩ǂ𔻒肷郁\bhB*/
	public boolean contains(int x, int y, UnitGraphicsEngine uge) {
		return uge.contains(x, y, this);
	}
	/** ̃jbgNbNꂽƂɂǂ̂悤ȓ邩̃_ufBXpb`ȃ\bhB*/
	public void clicked(UnitController controller) {
		controller.clicked(this);
	}

	//public void repaint() {
	//	uge.repaint();
	//}

	public void setBoard(Board board) {
		this.board = board;
	}
	public Board getBoard() { return board; }

	/**
	 * Ă邩(HP[傫A
	 * ȂՏ̐ʒuɑ݂邩)`FbNB
	*/
	public boolean checkExistence() {
		if (hp > 0) {
			if (this == board.getUnit(x,y))
				return true;
			else
				return false;
		}
		else {
			return false;
		}
	}

	/** {[h玩g폜B */
	public void remove() {
		if (this == board.getUnit(x,y))
			board.removeUnit(x,y);
	}

	/** Ƃė^ꂽjbgG𔻕ʂ */
	boolean checkEnemy(Unit unIdentification) {
		if (unIdentification != null) {
			if ( getNationality() != unIdentification.getNationality() )
				return true;
			else
				return false;
		}
		else
			return false;
	}


	/** UnitɉωƂAUnitĎĂ邷ׂẴXi[ɒʒm郁\bhłB*/
	void fireStateChanged() {

		Object[] listenersArray;

		// ݁AύXʒmł邩ǂB
		// ʒmłꍇ́AȂɂ^[B
		// ʒmłȂꍇnotifyingtrueɂāA؂ẴXi[ɒʒm͂߂B
		if (notifying) {
			return;
		} else {
			notifying = true;
		}

		// ʒmׂXi[zɁB
		synchronized (this) {
			listenersArray = listeners.toArray();
		}

		// ʒmCxg̍쐬B
		UnitEvent unitEvent = new UnitEvent(this);

		// قǔz񉻂Xi[ɁACxgʒmB
		for (int i = listenersArray.length-1; i >= 0; i--) {
			((UnitListener)listenersArray[i]).stateChanged(unitEvent);
		}

		// ׂẴXi[ɕύXʒm̂notifyingfalseɁB
		notifying = false;
	}

	/** UnitړƂAUnitĎĂ邷ׂẴXi[ɒʒm郁\bhłB*/
	void fireMoved(int oldX, int oldY) {

		Object[] listenersArray;

		// ݁AύXʒmł邩ǂB
		// ʒmłꍇ́AȂɂ^[B
		// ʒmłȂꍇnotifyingtrueɂāA؂ẴXi[ɒʒm͂߂B
		if (notifying) {
			return;
		} else {
			notifying = true;
		}

		// ʒmׂXi[zɁB
		synchronized (this) {
			listenersArray = listeners.toArray();
		}

		// ʒmCxg̍쐬B
		UnitEvent unitEvent = new UnitEvent(this, oldX, oldY);

		// قǔz񉻂Xi[ɁACxgʒmB
		for (int i = listenersArray.length-1; i >= 0; i--) {
			((UnitListener)listenersArray[i]).moved(unitEvent);
		}

		// ׂẴXi[ɕύXʒm̂notifyingfalseɁB
		notifying = false;
	}
}
