/** NH[^[r[p̕`GW */
package tk.mtantyukityuki.threeKingdoms.unit.graphicsEngine;

import tk.mtantyukityuki.threeKingdoms.model.*;
import tk.mtantyukityuki.threeKingdoms.unit.*;

import java.awt.*;
import java.awt.image.*;
//import java.applet.*;
//import java.awt.event.*;

public class UnitGraphicsEngineApplicationQuarter extends UnitGraphicsEngine {

	static UnitGraphicsEngineApplicationQuarter uge;
	Frame frame;

	static Image imgTakeda[] = new Image[8];
	static Image imgSoldier[] = new Image[8];
	static Image imgSquare;
	static Image imgSquare1;
	static Image imgWater;
	static Image imgSlope[] = new Image[8];
	static Image imgCity;
	static Image imgForest0;
	static Image imgForest;
	static Image imgFarm;

	private UnitGraphicsEngineApplicationQuarter() {

		// NX[_[ƁAToolKit̎擾B
		ClassLoader cl = this.getClass().getClassLoader();
		Toolkit tk = Toolkit.getDefaultToolkit();

		// NX[_[𗘗pgift@C̃oCif[^ǂ݂݁A
		// Toolkig𗘗pāÃoCif[^ƂImageIuWFNg쐬A
		// 쐬ꂽImageIuWFNg̃AṽACRɐݒ肷B

		// cRnRc摜̓ǂݍ݁B
		for (int i = 0; 8 > i; i++) {
			imgTakeda[i] = tk.createImage(
				cl.getResource("resources/takeda" + i + ".gif") );
		}

		// 摜̓ǂݍ݁B
		for (int i = 0; 8 > i; i++) {
			imgSoldier[i] = tk.createImage(
				cl.getResource("resources/soldier" + i + ".gif") );
		}

		// n`XNEFA̓ǂݍ݁B
		imgSquare = tk.createImage( cl.getResource("resources/square.gif") );
		imgSquare1 = tk.createImage( cl.getResource("resources/square1.gif") );
		imgWater = tk.createImage( cl.getResource("resources/water.gif") );

		// Ζʂ̓ǂݍ݁B
		for (int i = 0; 8 > i; i++) {
			imgSlope[i] = tk.createImage(
				cl.getResource("resources/slope" + i + ".gif") );
		}

		// ss摜̓ǂݍ݁B
		imgCity = tk.createImage( cl.getResource("resources/city.gif") );

		// Xщ摜̓ǂݍ݁B
		imgForest0 = tk.createImage( cl.getResource("resources/forest0.gif") );
		imgForest = tk.createImage( cl.getResource("resources/forest.gif") );

		// _n摜̓ǂݍ݁B
		imgFarm = tk.createImage( cl.getResource("resources/farm.gif") );
	}

	private UnitGraphicsEngineApplicationQuarter(MediaTracker mediaTracker,
																Frame frame ) {

		this.frame = frame;
		mediaTracker = mediaTracker;
		int mediaTrackerID = 0;

		// NX[_[ƁAToolKit̎擾B
		ClassLoader cl = this.getClass().getClassLoader();
		Toolkit tk = Toolkit.getDefaultToolkit();

		// NX[_[𗘗pgift@C̃oCif[^ǂ݂݁A
		// Toolkig𗘗pāÃoCif[^ƂImageIuWFNg쐬A
		// 쐬ꂽImageIuWFNg̃AṽACRɐݒ肷B

		// 摜̓ǂݍ݁B
		for (int i = 0; 8 > i; i++) {
			imgSoldier[i] = tk.createImage(
					cl.getResource("resources/soldier" + i + ".gif") );
			mediaTracker.addImage(imgSoldier[i], mediaTrackerID);
		}

		// cRnRc摜̓ǂݍ݁B
		for (int i = 0; 8 > i; i++) {
			imgTakeda[i] = tk.createImage(
					cl.getResource("resources/takeda" + i + ".gif") );
			mediaTracker.addImage(imgTakeda[i], mediaTrackerID);
		}

		// 󔒂̃XNEFA̓ǂݍ݁B
		imgSquare = tk.createImage( cl.getResource("resources/square.gif") );
		mediaTracker.addImage(imgSquare, mediaTrackerID);
		imgSquare1 = tk.createImage( cl.getResource("resources/square1.gif") );
		mediaTracker.addImage(imgSquare1, mediaTrackerID);
		imgWater = tk.createImage( cl.getResource("resources/water.gif") );
		mediaTracker.addImage(imgWater, mediaTrackerID);

		// Ζʂ̓ǂݍ݁B
		for (int i = 0; 8 > i; i++) {
			imgSlope[i] = tk.createImage(
					cl.getResource("resources/slope" + i + ".gif") );
			mediaTracker.addImage(imgSlope[i], mediaTrackerID);
		}

		// ss摜̓ǂݍ݁B
		imgCity = tk.createImage( cl.getResource("resources/city.gif") );
		mediaTracker.addImage(imgCity, mediaTrackerID);

		// Xщ摜̓ǂݍ݁B
		imgForest0 = tk.createImage( cl.getResource("resources/forest0.gif") );
		imgForest = tk.createImage( cl.getResource("resources/forest.gif") );
		mediaTracker.addImage(imgForest0, mediaTrackerID);
		mediaTracker.addImage(imgForest, mediaTrackerID);

		// _n摜̓ǂݍ݁B
		imgFarm = tk.createImage( cl.getResource("resources/farm.gif") );
		mediaTracker.addImage(imgFarm, mediaTrackerID);

		try {
			//C[W̋[hv
			mediaTracker.waitForID(mediaTrackerID);
		} catch (InterruptedException e) {
			return;
		}
	}

	/** ̃CX^X𓾂邽߂̃\bhB*/
	public static synchronized UnitGraphicsEngineApplicationQuarter getInstance() {
		if (uge == null) {
			uge = new UnitGraphicsEngineApplicationQuarter();
		}
		return uge;
	}

	/** ̃CX^X𓾂邽߂̃\bhB*/
	public static synchronized UnitGraphicsEngineApplicationQuarter getInstance(
							MediaTracker mediaTracker, Frame frame) {

		if (uge == null) {
			uge = new UnitGraphicsEngineApplicationQuarter(mediaTracker, frame);
		}
		return uge;
	}

	/** ͂gĂȂ\bhB */
	public void repaint() {
		frame.repaint();
	}


	/** jbg`悷郋[`B */
	public void show(Graphics g, int viewerX, int viewerY,
					Unit unit, Component view, Direction direction) {
		g.drawImage(imgSquare, viewerX - 53, viewerY - 27, view);
	}

	/** w肳ꂽWAunit̋Eɂ邩ǂ𔻒肷郁\bhB*/
	public boolean contains(int x, int y, Unit unit) {

		boolean retContains = false;

		if (-53 <= x && x <= 0) {
			if ( 0-(x/2+54) <= y && y <= x/2+27 ) {
				retContains = true;
			}
		} else if ( 0 < x && x <= 53 ) {
			if ( x/2-54 <= y && y <= 0-(x/2)+27 ) {
				retContains = true;
			}
		}

		return retContains;
	}


	/** n`jbg`悷郋[`B */
	public void show(Graphics g, int viewerX, int viewerY,
						Ground ground, Component view, Direction direction) {

		// IjbgȂтɌz`悷邽߂̕␳lB
		int modificationX = 0;
		int modificationY = 0;

		switch (ground.getGroundKind()) {
			case -3:
				// n``B
				g.drawImage(imgWater, viewerX - 53, viewerY - 13, view);
				modificationY = +13;
				break;
			case 0:
				// n``B
				g.drawImage(imgSquare, viewerX - 53, viewerY - 27, view);
				break;
			case 1:
				// n``B
				g.drawImage(imgSquare1, viewerX - 53, viewerY - 54, view);
				modificationY = -27;
				break;
		}

		// n``悵̂ɁAɒn`̂ɔzuĂ郆jbg`B

		Structure structure = ground.getStructure();
		if (structure != null) {
			structure.show(g, viewerX + modificationX, viewerY + modificationY,
															this, view, direction);
		} else {
			Creature creature = ground.getCreature();
			if (creature != null) {
				creature.show(g, viewerX + modificationX, viewerY + modificationY,
															this, view, direction);
			}
		}
	}

	/** Ζʃjbg`悷郋[`B */
	public void show(Graphics g, int viewerX, int viewerY,
							Slope slope, Component view, Direction direction) {

		int modificationX = 0;
		int modificationY = 0;

		int dirc = ((direction.getRelativeDirection(slope.getDirection()))-1)&7;

		switch (dirc) {
			case 1:
			case 5:
			case 7:
				// n``B
				g.drawImage(imgSlope[dirc], viewerX - 53, viewerY - 27, view);
				modificationY = -13;
				break;
			case 3:
				// n``B
				g.drawImage(imgSlope[dirc], viewerX - 53, viewerY - 54, view);
				modificationY = -13;
				break;
			case 0:
			case 6:
				// n``B
				g.drawImage(imgSlope[dirc], viewerX - 53, viewerY - 27, view);
				modificationY = -13;
				break;
			case 2:
			case 4:
				// n``B
				g.drawImage(imgSlope[dirc], viewerX - 53, viewerY - 54, view);
				modificationY = -13;
				break;
		}


		// n``悵̂ɁAɒn`̂ɔzuĂ郆jbg`B
		Creature creature = slope.getCreature();
		if (creature != null) {
			creature.show(g, viewerX + modificationX, viewerY + modificationY,
															this, view, direction);
		}
	}

	/** zjbg`悷郋[`B */
	public void show(Graphics g, int viewerX, int viewerY,
						Structure structure, Component view, Direction direction) {
		Creature creature =
			structure.getBoard().getCreature(structure.getX(), structure.getY());
		if (creature != null) {
			creature.show(g, viewerX, viewerY, this, view, direction);
		}
	}

	/** ssjbg`悷郋[`B */
	public void show(Graphics g, int viewerX, int viewerY,
						City city, Component view, Direction direction) {
		g.drawImage(imgCity, viewerX - 53, viewerY - 107, view);
	}

	/** Xуjbg`悷郋[`B */
	public void show(Graphics g, int viewerX, int viewerY,
						Forest forest, Component view, Direction direction) {
		if (0 == forest.getAge()) {
			g.drawImage(imgForest0, viewerX - 53, viewerY - 53, view);

			Creature creature =
					forest.getBoard().getCreature(forest.getX(), forest.getY());
			if (creature != null) {
				creature.show(g, viewerX, viewerY, this, view, direction);
			}
		} else {
			Creature creature =
					forest.getBoard().getCreature(forest.getX(), forest.getY());
			if (creature != null) {
				creature.show(g, viewerX, viewerY, this, view, direction);
			}

			g.drawImage(imgForest, viewerX - 53, viewerY - 53, view);
		}
	}

	/** _njbg`悷郋[`B */
	public void show(Graphics g, int viewerX, int viewerY,
								Farm farm, Component view, Direction direction) {
		g.drawImage(imgFarm, viewerX - 53, viewerY - 53, view);

		Creature creature =
					farm.getBoard().getCreature(farm.getX(), farm.getY());
		if (creature != null) {
			creature.show(g, viewerX, viewerY, this, view, direction);
		}
	}

	/** w肳ꂽWAcity̋Eɂ邩ǂ𔻒肷郁\bhB*/
	public boolean contains(int x, int y, City city) {

		boolean retContains = false;

		if (-53 <= x && x <= 0) {
			if (0-(x/2+54) <= y && y <= x/2+134) {
				retContains = true;
			}
		} else if (0 < x && x <= 53) {
			if (x/2-54 <= y && y <= 0-(x/2)+134) {
				retContains = true;
			}
		}

		return retContains;
	}


	/** Ijbg`悷郋[`B */
	public void show(Graphics g, int viewerX, int viewerY,
						Creature creature, Component view, Direction direction) {

		g.drawImage(imgTakeda[creature.getDirection().getDirection()],
												viewerX - 22, viewerY - 48, view);
	}

	/** Rjbg`悷郋[`B */
	public void show(Graphics g, int viewerX, int viewerY,
								Army army, Component view, Direction direction) {

		if (Army.NORMAL == army.getKind()) {
			g.drawImage(
				imgSoldier[
					((direction.getRelativeDirection(army.getDirection()))-1)&7
				],
				viewerX - 18, viewerY - 27, view);
		} else if (Army.TAKEDA_TROOPS == army.getKind()) {
			g.drawImage(
				imgTakeda[
					((direction.getRelativeDirection(army.getDirection()))-1)&7
				],
				viewerX - 22, viewerY - 48, view);
		} else {
			g.drawImage(
				imgSoldier[
					((direction.getRelativeDirection(army.getDirection()))-1)&7
				],
				viewerX - 18, viewerY - 27, view);
		}
	}

	/** mjbg`悷郋[`B */
	public void show(Graphics g, int viewerX, int viewerY,
			Soldier soldier, Component view, Direction direction) {

		g.drawImage(
			imgTakeda[soldier.getDirection().getDirection()],
			viewerX - 22, viewerY - 48, view
		);
	}

	/** wjbg`悷郋[`B */
	public void show(Graphics g, int viewerX, int viewerY,
					Commander commander, Component view, Direction direction) {

		g.drawImage(
			imgTakeda[commander.getDirection().getDirection()],
			viewerX - 22, viewerY - 48, view
		);

	}



}
