/**
 * Ȑ\ComponentB
 */
package tk.mtantyukityuki.threeKingdoms.view.swing;

import tk.mtantyukityuki.threeKingdoms.model.*;
import tk.mtantyukityuki.threeKingdoms.unit.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


class ArmyViewer extends JPanel implements UnitListener {

	Army army;

	JLabel soldier;
	JLabel horse;
	JLabel archery;

	static Icon soldierIcon;
	static Icon horseIcon;
	static Icon archeryIcon;

	public ArmyViewer(Army army) {

		this.army = army;

		// NX[_[ƁAToolKit̎擾B
		ClassLoader cl = this.getClass().getClassLoader();

		// NX[_[𗘗pgift@C̃oCif[^ǂ݂݁A
		// Toolkig𗘗pāÃoCif[^ƂImageIuWFNg쐬B
		soldierIcon = new ImageIcon(cl.getResource("resources/soldier.gif"));
		horseIcon = new ImageIcon(cl.getResource("resources/horse.gif"));
		archeryIcon = new ImageIcon(cl.getResource("resources/archery.gif"));

		soldier = new JLabel(soldierIcon,SwingConstants.CENTER);
		horse = new JLabel(horseIcon, SwingConstants.CENTER);
		archery = new JLabel(archeryIcon,SwingConstants.CENTER);

		setLayout(new FlowLayout());

		add(soldier);
		add(horse);
		add(archery);

		updateData();

		army.addUnitListener(this);
	}


	/**
	 * `悷Rf[^ŐV̏Ԃɂ郁\bhB
	 */
	void updateData() {
		Integer soldierNumber = new Integer(army.getNumberOfSoldier());
		Integer horseNumber = new Integer(army.getNumberOfHorse());
		Integer archeryNumber = new Integer(army.getNumberOfArchery());

		soldier.setText(soldierNumber.toString());
		horse.setText(horseNumber.toString());
		archery.setText(archeryNumber.toString());
	}

	public void paintComponent(Graphics g) {
		updateData();
		super.paintComponent(g);
	}

	public void stateChanged(UnitEvent unitEvent) {
		repaint();
	}
	public void moved(UnitEvent unitEvent) {
		repaint();
	}
}

