/**
 * C^[it[̐Ȃǂ܂Ƃ߂ĊǗCX^XB
 * ̃CX^X݂̑ɂAȂssAȂRɂĂ̏\EChÉA˂ɈȂB
 */
package tk.mtantyukityuki.threeKingdoms.view.swing;

import tk.mtantyukityuki.threeKingdoms.model.*;
import tk.mtantyukityuki.threeKingdoms.unit.*;

import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import java.beans.*;
import java.util.*;


class WindowAdapter implements InternalFrameListener {
	Unit unit;
	JInternalFrame internalFrame;


	public Unit getUnit() { return unit; }
	public JInternalFrame getInternalFrame() { return internalFrame; }

	public void setUnit(Unit unit) { this.unit = unit; }
	public void setInternalFrame(JInternalFrame frame) { internalFrame = frame; }


	public WindowAdapter(Unit unit) {
		this.unit = unit;
	}


	public boolean equals(Object obj) {

		if ( this.getClass() == obj.getClass() ) {
			if ( unit == ((WindowAdapter)obj).getUnit() ) {
				return true;
			}
			else {
				return false;
			}
		}
		else {
			return false;
		}
	}

	public void internalFrameClosed(InternalFrameEvent e) {
		WindowsManager.getInstance().getCityInformationCollection().remove(this);
	}

	public void internalFrameOpened(InternalFrameEvent e) {}
	public void internalFrameClosing(InternalFrameEvent e) {}
	public void internalFrameIconified(InternalFrameEvent e) {}
	public void internalFrameDeiconified(InternalFrameEvent e) {}
	public void internalFrameActivated(InternalFrameEvent e) {}
	public void internalFrameDeactivated(InternalFrameEvent e) {}
}


public class WindowsManager {

	static WindowsManager windowsManager;
	JDesktopPane desktop;

	Collection cityInformationCollection = new LinkedList();

	private WindowsManager() {
		desktop = ThreeKingdoms.getDesktop();
	};

	public static synchronized WindowsManager getInstance() {
		if ( windowsManager == null ) {
			windowsManager = new WindowsManager();
		}
		return windowsManager;
	}

	public Collection getCityInformationCollection() {
		return cityInformationCollection;
	}


	/** sR}bv\邽߂̃C^[it[쐬郁\bhB*/
	public JInternalFrame createMapWindow(Board board,
							Integer layer, int x, int y, int width, int height) {

		JInternalFrame internalFrame = new JInternalFrame("sR}bv");
		QuarterViewer viewer = new QuarterViewer(board);
		StrategyWindowInformation infoViewer =
									new StrategyWindowInformation(viewer);
		viewer.setInformationViewer(infoViewer);

		/*
		 * NX[_[g resourcestH_̃t@Cǂ݂݁A
		 * ̃C^[it[ɃACR摜ݒ肷B
		 */

		// NX[_[擾AACR쐬A쐬ACRC^[it[ɐݒB
		ClassLoader cl = this.getClass().getClassLoader();
		internalFrame.setFrameIcon( new ImageIcon(
				cl.getResource("resources/uma.gif") ));

		/*
		 * C^[iEChE̐ݒ
		 * 邱ƂłAő剻邱ƂłATCY̕ύXłAŏ邱ƂłB
		 */
		internalFrame.setClosable(true);
		internalFrame.setMaximizable(true);
		internalFrame.setResizable(true);
		internalFrame.setIconifiable(true);


		// fBXNgbvɁÃC^[it[ǉB
		desktop.add(internalFrame, layer);

		/*
		 * C^[iEChEɐݒ肷LoX̍쐬B
		 */

		JComponent component = (JComponent) internalFrame.getContentPane();
		component.setLayout(new BorderLayout());

		component.add("Center", viewer);
		component.add("South", infoViewer);


		try {
			internalFrame.setSelected(true);
		} catch (java.beans.PropertyVetoException e2) {
		}

		// ʂɕ\āA傫ƕ\ʒuݒB
		internalFrame.show();
		internalFrame.setBounds(x, y, width, height);

		return internalFrame;

	}

	public JInternalFrame createCityWindow(City city,
							Integer layer, int x, int y, int width, int height) {

		JInternalFrame internalFrame;
		WindowAdapter windowAdapter;

		Iterator iterator = cityInformationCollection.iterator();
		while(iterator.hasNext()) {
			windowAdapter = (WindowAdapter)(iterator.next());

			if (city == windowAdapter.getUnit()) {
				JInternalFrame frame = windowAdapter.getInternalFrame();

				if (frame.isIcon()) {
					try {
						frame.setIcon(false);
					} catch (PropertyVetoException error) { }


				}
				frame.toFront();

				return null;
			}
		}

		windowAdapter = new WindowAdapter(city);
		cityInformationCollection.add(windowAdapter);

		String cityName = city.getName();
		if (cityName == null) {
			cityName = "ss";
		}

		internalFrame = new JInternalFrame(cityName);
		internalFrame.addInternalFrameListener(windowAdapter);

		windowAdapter.setInternalFrame(internalFrame);
		CityViewer viewer = new CityViewer(city);

		JComponent component = (JComponent) internalFrame.getContentPane();
		component.setLayout(new BorderLayout());
		component.add("Center", viewer);

		/*
		 * C^[iEChE̐ݒ
		 * 邱ƂłAő剻邱ƂłATCY̕ύXłAŏ邱ƂłB
		 */
		internalFrame.setClosable(true);
		internalFrame.setMaximizable(true);
		internalFrame.setResizable(true);
		internalFrame.setIconifiable(true);


		// fBXNgbvɁÃC^[it[ǉB
		desktop.add(internalFrame, layer);

		try {
			internalFrame.setSelected(true);
		} catch (java.beans.PropertyVetoException e2) { }


		// ʂɕ\āA傫ƕ\ʒuݒB
		internalFrame.show();
		internalFrame.setBounds(x, y, width, height);

		return internalFrame;
	}

	public JInternalFrame createMakeArmyDialog(City city,
							Integer layer, int x, int y, int width, int height) {

		String cityName = city.getName();
		if (cityName == null) {
			cityName = "ss";
		}
		JInternalFrame internalFrame = new JInternalFrame(cityName + " R쐬");
		MakeArmyDialog viewer = new MakeArmyDialog(city);

		JComponent component = (JComponent) internalFrame.getContentPane();
		component.setLayout(new BorderLayout());
		component.add("Center", viewer);

		/*
		 * C^[iEChE̐ݒ
		 * 邱ƂłAő剻邱ƂłATCY̕ύXłAŏ邱ƂłB
		 */
		internalFrame.setClosable(true);
		internalFrame.setMaximizable(true);
		internalFrame.setResizable(true);


		// fBXNgbvɁÃC^[it[ǉB
		desktop.add(internalFrame, layer);

		try {
			internalFrame.setSelected( true );
		} catch (java.beans.PropertyVetoException e2) { }

		// ʂɕ\āA傫ƕ\ʒuݒB
		internalFrame.show();
		internalFrame.setBounds(x, y, width, height);

		return internalFrame;
	}

	public JInternalFrame createArtisanDialog(City city,
						Integer layer, int x, int y, int width, int height) {

		String cityName = city.getName();
		if (cityName == null) {
			cityName = "ss";
		}
		JInternalFrame internalFrame = new JInternalFrame(cityName + " 퐻䗦");
		ArtisanPercentDialog viewer = new ArtisanPercentDialog(city);

		JComponent component = (JComponent) internalFrame.getContentPane();
		component.setLayout(new BorderLayout());
		component.add("Center", viewer);

		/*
		 * C^[iEChE̐ݒ
		 * 邱ƂłAő剻邱ƂłATCY̕ύXłAŏ邱ƂłB
		 */
		internalFrame.setClosable(true);


		// fBXNgbvɁÃC^[it[ǉB
		desktop.add(internalFrame, layer);

		try {
			internalFrame.setSelected(true);
		} catch (java.beans.PropertyVetoException e2) { }

		// ʂɕ\āA傫ƕ\ʒuݒB
		internalFrame.show();
		internalFrame.setBounds(x, y, width, height);

		return internalFrame;
	}

	public JInternalFrame createArmyWindow(Army army, Integer layer, int x, int y, int width, int height) {

		JInternalFrame internalFrame;
		WindowAdapter windowAdapter;

		Iterator iterator = cityInformationCollection.iterator();
		while(iterator.hasNext()) {
			windowAdapter = (WindowAdapter)(iterator.next());

			if (army == windowAdapter.getUnit()) {
				JInternalFrame frame = windowAdapter.getInternalFrame();

				if (frame.isIcon()) {
					try {
						frame.setIcon(false);
					} catch (PropertyVetoException error) { }


				}
				frame.toFront();

				return null;
			}
		}

		windowAdapter = new WindowAdapter(army);
		cityInformationCollection.add( windowAdapter );

		String armyName = army.getName();
		if (armyName == null) {
			armyName = "R";
		}
		internalFrame = new JInternalFrame(armyName);
		internalFrame.addInternalFrameListener(windowAdapter);

		windowAdapter.setInternalFrame(internalFrame);
		ArmyViewer viewer = new ArmyViewer(army);

		JComponent component = (JComponent) internalFrame.getContentPane();
		component.setLayout(new BorderLayout());
		component.add("Center", viewer);

		/*
		 * C^[iEChE̐ݒ
		 * 邱ƂłAő剻邱ƂłATCY̕ύXłAŏ邱ƂłB
		 */
		internalFrame.setClosable(true);
		internalFrame.setMaximizable(true);
		internalFrame.setResizable(true);
		internalFrame.setIconifiable(true);


		// fBXNgbvɁÃC^[it[ǉB
		desktop.add(internalFrame, layer);

		try {
			internalFrame.setSelected(true);
		}
		catch (java.beans.PropertyVetoException e2) { }


		// ʂɕ\āA傫ƕ\ʒuݒB
		internalFrame.show();
		internalFrame.setBounds(x, y, width, height);

		return internalFrame;
	}
}

