/** Q[Ղ킷NXB̃IuWFNg̏ɒn`jbgss▯OjbgRjbgzuB̃NX̂IuWFNg͒嗤Ŝ킷A܂ׂ̃IuWFNǵAvC[RǦRƏoƂɍ쐬킷B */
package tk.mtantyukityuki.threeKingdoms.model;

import tk.mtantyukityuki.threeKingdoms.unit.*;

import java.util.*;

public class Board implements UnitListener {

	/** jbgzu閑ڂ킵܂B
	̃}X̏ɂ܂n`jbg(GroundNX̃IuWFNg)zuA
	ɂ̒n`jbg̏Ɍzjbg(StructureNX̃IuWFNg)A
	Rjbg▯Ojbg(CreatureNX̃IuWFNg)zu܂B*/
	Unit square[][];

	/** Boardx̑傫킵܂B*/
	int sizeX;
	/** Boardy̑傫킵܂B*/
	int sizeY;


	/** ԂƂƂɎω郆jbg̃XgłB
	ԂƂƂɎω郆jbgƂ́A
	cEXсAOERAERE|Ȃǂ̂ƂŁA
	̓IɂRunnableUnitC^[tFCXjbĝƂłB

	̃Xgɓo^ꂽSUnitɑ΂run()\bhĂяoƁA
	1^[IA܂ӂт̃Xg̐擪Unitɑ΂
	run()ĂяoAQ[isĂ䂫܂B*/
	RunnableUnitList runnableUnitList;

	/** 򗈕zu郊XgB(тEeۂȂ)
	ȂLrunnableUnitListƂׂ͂ɂ̕ϐpӂ̂
	悭oĂ܂񂪁Ai|IL݂Ȃɂ
	`揈Ƃ̊֌W悤ȋC܂B*/
	RunnableUnitList flyingUnitList;

	/** Q[̃Xs[h킵܂B
	̐lقǃQ[̐isx͑A傫ΒxȂ܂B
	A̐l0ȂQ[̓Xgbv܂B(ꎞ~) */
	Time speed;


	/** ݁AXi[ɕύXʒmł邩ǂۑϐłB*/
	boolean notifying;

	/**
	 * UnitListenerƂĂ̂BoardCX^XAقUnitCX^XCxg󂯎ƂA
	 * ̃Cxg`ׂXi[ێ邽߂̕ϐB
	 * ̓`ׂXi[Ƃ͋̓Iɂ̓}bv`悷邽߂QuarterViewerȂǁB
	 */
	Vector listeners = new Vector();

	public Board(int sizeX, int sizeY, Time time) {

		this.speed = time;

		this.sizeX = sizeX;
		this.sizeY = sizeY;

		square = new Unit[sizeX][sizeY];
		for (int x = 0; x < sizeX; x++)
			for (int y = 0; y < sizeY; y++)
				square[x][y] = null;

		flyingUnitList = new RunnableUnitList( time );
		runnableUnitList = new RunnableUnitList( time );

	}

	public void remove() {

		setSpeed(0);

		for (int x = 0; x < sizeX; x++)
			for (int y = 0; y < sizeY; y++)
				removeUnit(x, y);

		flyingUnitList = null;
		runnableUnitList = null;

	}

	public RunnableUnitList getFlyingUnitList() { return flyingUnitList; }
	public RunnableUnitList getRunnableUnitList() { return runnableUnitList; }

	public int getSizeX() { return sizeX; }
	public int getSizeY() { return sizeY; }

	/** Xs[hIuWFNgύX */
	public void setSpeedObj(Time speed) { this.speed = speed; }
	public void setSpeed(int speed) { this.speed.setSpeed( speed ); }

	/** Xs[hIuWFNgύXB */
	public Time getSpeedObj() { return speed; }
	public int getSpeed() { return speed.getSpeed(); }


	/** Տ̑SXbhrunB */
	public void startAllUnit() {
		runnableUnitList.start();
		flyingUnitList.start();
	}


	public Unit getUnit(int x, int y) {
		if (0 <= x && x < sizeX && 0 <= y && y < sizeY)
			return square[x][y];
		else
			return null;
	}
	public boolean setUnit(int x, int y, Unit unit) {
		if (0 <= x && x < sizeX && 0 <= y && y < sizeY) {
			square[x][y] = unit;
			return true;
		} else {
			return false;
		}
	}
	public void removeUnit(int x, int y) {
		if (0 <= x && x < sizeX && 0 <= y && y < sizeY)
			square[x][y] = null;
	}

	public Ground getGround(int x, int y) {
		if (0 <= x && x < sizeX && 0 <= y && y < sizeY)
			return (Ground)square[x][y];
		else
			return null;
	}
	public boolean setGround(int x, int y, Ground unit) {
		if (0 <= x && x < sizeX && 0 <= y && y < sizeY) {
			square[x][y] = unit;
			return true;
		} else {
			return false;
		}
	}
	public void removeGround(int x, int y) {
		if (0 <= x && x < sizeX && 0 <= y && y < sizeY)
			square[x][y] = null;
	}


	public Structure getStructure(int x, int y) {
		if (0 <= x && x < sizeX && 0 <= y && y < sizeY)
			return ( (Ground)square[x][y] ).getStructure();
		else
			return null;
	}
	public boolean setStructure(int x, int y, Structure structure) {
		if (0 <= x && x < sizeX && 0 <= y && y < sizeY) {
			( (Ground)square[x][y] ).setStructure(structure);
			return true;
		} else {
			return false;
		}
	}
	public void removeStructure(int x, int y) {
		if (0 <= x && x < sizeX && 0 <= y && y < sizeY) {
			( (Ground)square[x][y] ).removeStructure();
		}
	}

	public Creature getCreature(int x, int y) {
		if (0 <= x && x < sizeX && 0 <= y && y < sizeY) {
			return ( (Ground)square[x][y] ).getCreature();
		}
		else {
			return null;
		}
	}
	public boolean contains(int x, int y, Creature creature) {
		if (0 <= x && x < sizeX && 0 <= y && y < sizeY) {
			return ( (Ground)square[x][y] ).contains(creature);
		}
		else {
			return false;
		}
	}
	public boolean setCreature(int x, int y, Creature creature) {
		if (0 <= x && x < sizeX && 0 <= y && y < sizeY) {
			return ( (Ground)square[x][y] ).setCreature(creature);
		}
		else {
			return false;
		}
	}

	public boolean removeCreature(int x, int y) {
		if (0 <= x && x < sizeX && 0 <= y && y < sizeY) {
			return ( (Ground)square[x][y] ).removeCreature();
		}
		else {
			return false;
		}
	}

	public boolean removeCreature(int x, int y, Creature creature ) {
		if (0 <= x && x < sizeX && 0 <= y && y < sizeY) {
			return ( (Ground)square[x][y] ).removeCreature( creature );
		}
		else {
			return false;
		}
	}


	/**
	 * creatureŎ󂯎CreaturejbgAdest_x,dest_ÿʒuɈړB
	 * ΐ^ԂAs΋UԂB
	 */
	public boolean moveCreature(Creature creature, int destX, int destY) {

		if ( 0 <= destX && destX < sizeX && 0 <= destY && destY < sizeY ) {

			int tempX = creature.getX();
			int tempY = creature.getY();

			if ( setCreature( destX, destY, creature ) ) {
				removeCreature( tempX, tempY, creature );
				return true;
			}
			else {
				return false;
			}

		}
		else {
			return false;
		}
	}

	/**
	 * CreaturejbgՏɍŏɃZbgƂɂ郁\bhB
	 * CreatuerjbgRunnableUnitList֓o^A
	 * ̃{[hCX^XCraturejbg̃XiƂāACreaturejbgɓo^Ȃǂ̏sȂB
	 * ΐ^ԂAs΋UԂB
	 */
	public boolean firstSetCreature(int x, int y, Creature creature) {
		if ( setCreature(x, y, creature) ) {
			getRunnableUnitList().add(creature);
			creature.addUnitListener(this);
			return true;
		} else {
			return false;
		}
	}

	public boolean firstSetGround(int x, int y, Ground ground) {
		if ( setGround(x, y, ground) ) {
			if ( ground instanceof RunnableUnit ) {
				getRunnableUnitList().add((RunnableUnit)ground);
			}
			ground.addUnitListener(this);
			return true;
		} else {
			return false;
		}
	}

	public boolean firstSetStructure(int x, int y, Structure structure) {
		if ( setStructure(x, y, structure) ) {
			if ( structure instanceof RunnableUnit ) {
				getRunnableUnitList().add((RunnableUnit)structure);
			}
			structure.addUnitListener(this);
			return true;
		} else {
			return false;
		}
	}

	public void stateChanged(UnitEvent unitEvent) {
		Object[] listenersArray;

		// ݁AύXʒmł邩ǂB
		// ʒmłꍇ́AȂɂ^[B
		// ʒmłȂꍇnotifyingtrueɂāA؂ẴXi[ɒʒm͂߂B
		if (notifying) {
			return;
		} else {
			notifying = true;
		}

		// ʒmׂXi[zɁB
		synchronized (this) {
			listenersArray = listeners.toArray();
		}

		// قǔz񉻂Xi[ɁACxgʒmB
		for (int i = listenersArray.length-1; i >= 0; i--) {
			((UnitListener)listenersArray[i]).stateChanged(unitEvent);
		}

		// ׂẴXi[ɕύXʒm̂notifyingfalseɁB
		notifying = false;
	}

	public void moved(UnitEvent unitEvent) {

		Object[] listenersArray;

		// ݁AύXʒmł邩ǂB
		// ʒmłꍇ́AȂɂ^[B
		// ʒmłȂꍇnotifyingtrueɂāA؂ẴXi[ɒʒm͂߂B
		if (notifying) {
			return;
		} else {
			notifying = true;
		}

		// ʒmׂXi[zɁB
		synchronized (this) {
			listenersArray = listeners.toArray();
		}

		// قǔz񉻂Xi[ɁACxgʒmB
		for (int i = listenersArray.length - 1; i >= 0; i--) {
			((UnitListener)listenersArray[i]).stateChanged(unitEvent);
		}

		// ׂẴXi[ɕύXʒm̂notifyingfalseɁB
		notifying = false;
	}

	public void addUnitListener(UnitListener unitListener) {
		listeners.add(unitListener);
	}

	public void removeUnitListener(UnitListener unitListener) {
		listeners.remove(unitListener);
	}
}

