/** 킷NXłBUnitNXȂǂŎg܂B */
package tk.mtantyukityuki.threeKingdoms.model;

public class Direction {

	/** ݂ǂ̕Ă邩킵܂B
	̌ɂÂ萔UP,RIGHT,LEFTȂǂ̒li[܂B*/
	int direction;

	public static final int UP = 0;
	public static final int UP_RIGHT = 1;
	public static final int RIGHT = 2;
	public static final int DOWN_RIGHT = 3;
	public static final int DOWN = 4;
	public static final int DOWN_LEFT = 5;
	public static final int LEFT = 6;
	public static final int UP_LEFT = 7;

	public Direction(int direction) {
		this.direction = direction;
	}

	public Direction(Direction direction) {
		this.direction = direction.direction;
	}

	public int getDirection() { return direction; }
	public void setDirection(int direction) { this.direction = direction; }
	public void setDirection(Direction direction) { this.direction = direction.direction; }

	/** direction̔Α̕\bhłB*/
	public int getContrary() {

		int retDir;

		switch (direction) {
			case UP :
				retDir = DOWN;
				break;
			case RIGHT :
				retDir = LEFT;
				break;
			case DOWN :
				retDir = UP;
				break;
			case LEFT :
				retDir = RIGHT;
				break;

			case UP_RIGHT :
				retDir = DOWN_LEFT;
				break;
			case DOWN_RIGHT :
				retDir = UP_LEFT;
				break;
			case DOWN_LEFT :
				retDir = UP_RIGHT;
				break;
			case UP_LEFT :
				retDir = DOWN_RIGHT;
				break;

			default :
				retDir = DOWN;
				break;
		}

		return retDir;

	}

	/** Ɉԍ̍W(0,0)A
	Eɂ䂯x1Aɍsy̒l1WnƂA
	̍Wdirection̕Ɉ񂾂ƂɁA
	x̒lӂ₹΂Zo郁\bhB*/
	public int getNextX() {
		int retX = 0;

		switch (direction) {
			case RIGHT :
			case UP_RIGHT :
			case DOWN_RIGHT :
				retX++;
				break;

			case LEFT :
			case UP_LEFT :
			case DOWN_LEFT :
				retX--;
				break;
		}

		return retX;
	}

	/** Ɉԍ̍W(0,0)A
	Eɂ䂯x1Aɍsy̒l1WnƂA
	̍Wdirection̕Ɉ񂾂ƂɁA
	y̒lӂ₹΂Zo郁\bhB*/
	public int getNextY() {
		int retY = 0;

		switch (direction) {
			case UP :
			case UP_RIGHT :
			case UP_LEFT :
				retY--;
				break;

			case DOWN :
			case DOWN_RIGHT :
			case DOWN_LEFT :
				retY++;
				break;
		}

		return retY;
	}

	public int getNextX(int relativeDirection) {

		Direction absoluteUpDirection = new Direction(UP);
		Direction tempSourceDirection = new Direction(this);

		while ( absoluteUpDirection.getDirection() != relativeDirection ) {
			absoluteUpDirection.rightTurn();
			tempSourceDirection.rightTurn();
		}

		return tempSourceDirection.getNextX();
	}
	public int getNextY(int relativeDirection) {

		Direction absoluteUpDirection = new Direction(UP);
		Direction tempSourceDirection = new Direction(this);

		while ( absoluteUpDirection.getDirection() != relativeDirection ) {
			absoluteUpDirection.rightTurn();
			tempSourceDirection.rightTurn();
		}

		return tempSourceDirection.getNextY();
	}


	/**
	 * Ƃė^ꂽ_̍WƂɁAg̕ύX郋[`
	 * ύX́̕AsourceX,Y݂destX,Y̕ɂȂB
	 */
	public void calculateDirectionStoD(int sourceX, int sourceY, int destX, int destY) {

		if (sourceY == destY) {
			if (sourceX == destX) {
				// ȂB
			} else if (sourceX < destX) {
				direction = RIGHT; // ̍W͉EB
			} else {
				direction = LEFT; // ̍W͍B
			}
		} else if (sourceY < destY) {
			int relativeX = destX - sourceX;
			int relativeY = destY - sourceY;

			if ( relativeX >= (relativeY << 1)-1 ) {
				if ( (1 == relativeX) && (1 == relativeY) ) {
					direction = DOWN_RIGHT; // ̍W͉EB
				} else {
					direction = RIGHT; // ̍W͉EB
				}
			} else if ( relativeX >= (1+relativeY) >> 1 ) {
				direction = DOWN_RIGHT; // ̍W͉EB
			} else if ( relativeX >= 0 - ( (1+relativeY) >> 1) ) {
				if ( -1 == relativeX && 1 == relativeY ) {
					direction = DOWN_LEFT; // ̍W͍B
				} else {
					direction = DOWN; // ̍W͉B
				}
			} else if ( relativeX >= 0 - (relativeY << 1) ) {
				direction = DOWN_LEFT; // ̍W͍B
			} else {
				direction = LEFT; //̍W͍B
			}
		} else {
			int relativeX = destX - sourceX;
			int relativeY = 0 - (destY - sourceY);

			if ( relativeX <= 1 - (relativeY << 1) ) {
				if ( -1 == relativeX && 1 == relativeY ) {
					direction = UP_LEFT; // ̍W͍B
				} else {
					direction = LEFT; //̍W͍B
				}
			} else if ( relativeX <= 0 - ((1+relativeY) >> 1) ) {
				direction = UP_LEFT; // ̍W͍B
			} else if ( relativeX <= (1+relativeY) >> 1 ) {
				if ( 1 == relativeX && 1 == relativeY ) {
					direction = UP_RIGHT; // ̍W͉EB
				} else {
					direction = UP; // ̍W͏B
				}
			} else if ( relativeX <= relativeY << 1 ) {
				direction = UP_RIGHT; // ̍W͉EB
			} else {
				direction = RIGHT; // ̍W͉EB
			}
		}

	}

	/** ̕ɂĈƂė^ꂽǂĂ邩Zo郋[` */
	public int getRelativeDirection(Direction relativeDirection) {

		Direction tempSourceDirection = new Direction(this);
		Direction tempRelativeDirection = new Direction( relativeDirection );

		while (tempSourceDirection.getDirection() != Direction.UP) {
			tempSourceDirection.rightTurn();
			tempRelativeDirection.rightTurn();
		}

		return tempRelativeDirection.getDirection();
	}

	/** ɕ]郁\bhB*/
	public void leftTurn() {
		direction--;
		direction &= 7;
	}
	/** Eɕ]郁\bhB*/
	public void rightTurn() {
		direction++;
		direction &= 7;
	}
	/** 𔽑΂ɕύX郁\bhB*/
	public void contraryTurn() {
		direction = getContrary();
	}
	/** 90xA]郁\bhB*/
	public void leftNinetyTurn() {
		direction -= 2;
		direction &= 7;
	}
	/** E90xA]郁\bhB*/
	public void rightNinetyTurn() {
		direction += 2;
		direction &= 7;
	}

	public int getLeftTurn() {
		int tempDirection = direction;
		int retDirection;

		leftTurn();
		retDirection = direction;

		direction = tempDirection;
		return retDirection;
	}
	public int getRightTurn() {
		int tempDirection = direction;
		int retDirection;

		rightTurn();
		retDirection = direction;

		direction = tempDirection;
		return retDirection;
	}


}
