/** w */
package tk.mtantyukityuki.threeKingdoms.unit;

import tk.mtantyukityuki.threeKingdoms.model.*;
import tk.mtantyukityuki.threeKingdoms.unit.controller.*;
import tk.mtantyukityuki.threeKingdoms.unit.graphicsEngine.*;

import java.awt.*;

public class Commander extends Soldier implements Horse {

	Army army;	// ̎wwRB

	public Commander(int x, int y, Board tacticsField, Direction direction, int Nationality) {
		super(x,y, tacticsField, direction, Nationality);
	}
	public Commander(int x, int y, Board tacticsField, Direction direction, int Nationality, Unit target, boolean auto) {
		super(x,y, tacticsField, direction, Nationality, target, auto);
	}

	public void init() {
		maxHP = 100;
		hp = 100;
		offensivePower = 1;
		defensivePower = 5;

		presentSpeed = 0;
		maxSpeed = 4;
		acceleration = 2;

		attackSpeed = 4;

		movementPower = 0;
		attackSpeedPower = 0;
	}

	public Army getArmy() { return army; }
	public void setArmy( Army army ) { this.army = army; }

	public void show(Graphics g, int x, int y,
			UnitGraphicsEngine uge, Component view, Direction direction) {
		uge.show(g, x,y, this, view, direction);
	}

	/** {[h玩g폜B */
	public void remove() {

		// ̎Ԃ~B
		board.setSpeed(0);

		// {[h̓񎟌z񂩂玩g폜B
		if (this == board.getUnit(x,y))
			board.removeUnit(x,y);

		// {[hRunnableUnitList玩g폜B
		board.getRunnableUnitList().remove( this );

		// g̎wRjbgłB

	}

}

