/** Board̃jbgNH[^[r[ŕ\邽߂JPanel̃TuNXłB*/
package tk.mtantyukityuki.threeKingdoms.view.swing;

import tk.mtantyukityuki.threeKingdoms.model.*;
import tk.mtantyukityuki.threeKingdoms.unit.*;
import tk.mtantyukityuki.threeKingdoms.unit.controller.*;
import tk.mtantyukityuki.threeKingdoms.unit.graphicsEngine.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import java.util.*;
import javax.swing.event.*;
/**
import java.beans.*;
import java.io.*;
import java.net.URL;

import javax.swing.text.*;
import javax.swing.undo.*;
import java.applet.*;
*/

class QuarterViewer extends JPanel
		implements MouseListener, MouseMotionListener, UnitListener {

	/** QuarterViewer̃IuWFNgɁAǂBoardIuWFNg\̂w肷邽߂̃oϐłBȂ݂BoardNXƂ͍sRʂƂ퓬ʂȂǂ́unv킷NXłBBoard̏ǦRjbgsRAG̎sڎw܂B*/
	Board board;

	/** ݃}EXőIĂW̏\plłB*/
	StrategyWindowInformation infoViewer;

	/** jbg̃OtBbN`悷邽߂̃GWłBstaticȕϐɂĂ悤ȋC܂B*/
	UnitGraphicsEngine unitGraphicsEngine;


	// \BoardNX̃XNEFA̍WB
	int centerX = 8;
	int centerY = 8;

	// ݃}EXJ[\ȂǂőIĂXNEFA̍WB
	int currentX = 8;
	int currentY = 8;

	/** ̃IuWFNg`悷}bv̌w肷邽߂̃oϐłB܂肱̕ϐ邱ƂŃ}bv]邱Ƃł킯łB*/
	Direction direction;


	// XNEFÃTCYB
	int squareWidth = 107;
	int squareHeight = 55;

	// \NH[^[r[ʂ̑傫B
	int quarterViewScreenWidth;
	int quarterViewScreenHeight;

	/** Creaturejbghp(̗)\邩ǂw肵܂B*/
	boolean showHP = false;

	int mouseX;
	int mouseY;

	UnitController controller;

	// XN[͈͂Ȃǂ̎wB
	// }EXJ[\ʂ̒[ɂނscroolRangeɂ͂܂
	// (scrollWait / 1000)bo߂XN[B

	int scrollRange = 32;
	int scrollWait = 500;

	/* XN[͈͓Ń}EXNbNscrollConditiontOtrueɂāA
	ȂScrollThreadN܂B
		(Ȃ݂ɁAThreadQĂꏊscrollThreadB)
	܂A}EXJ[\
	QuarterViewer̃\bhɂfalseɍăZbgB*/

	static ScrollThread scrollThread;

	void scroll() {
		if (scrollRange > mouseX) {
			if ( scrollRange > mouseY ) {
				centerX += direction.getNextX(Direction.UP_LEFT);
				centerY += direction.getNextY(Direction.UP_LEFT);
			} else if (getHeight()- scrollRange < mouseY) {
				centerX += direction.getNextX(Direction.DOWN_LEFT);
				centerY += direction.getNextY(Direction.DOWN_LEFT);
			} else {
				centerX += direction.getNextX(Direction.LEFT);
				centerY += direction.getNextY(Direction.LEFT);
			}
		} else if (getWidth() - scrollRange < mouseX) {
			if (scrollRange > mouseY) {
				centerX += direction.getNextX(Direction.UP_RIGHT);
				centerY += direction.getNextY(Direction.UP_RIGHT);
			} else if (getHeight() - scrollRange < mouseY) {
				centerX += direction.getNextX(Direction.DOWN_RIGHT);
				centerY += direction.getNextY(Direction.DOWN_RIGHT);
			} else {
				centerX += direction.getNextX(Direction.RIGHT);
				centerY += direction.getNextY(Direction.RIGHT);
			}
		} else if (scrollRange > mouseY) {
			centerX += direction.getNextX(Direction.UP);
			centerY += direction.getNextY(Direction.UP);
		} else if (getHeight() - scrollRange < mouseY) {
			centerX += direction.getNextX(Direction.DOWN);
			centerY += direction.getNextY(Direction.DOWN);
		}

		if (0 > centerX)
			centerX = 0;
		if (0 > centerY)
			centerY = 0;
		if (board.getSizeX() < centerX)
			centerX = board.getSizeX();
		if (board.getSizeY() < centerY)
			centerY = board.getSizeY();
	}

	class ScrollThread extends Thread {

		QuarterViewer quarterViewer;

		boolean scrollCondition;

		ScrollThread() { start(); }
		public void run() {
			int adjustWait = 0;
			for (;;) {

				while (quarterViewer == null || !scrollCondition) {
					this.waitScroll();
					adjustWait = 0;
				}

				quarterViewer.scroll();
				quarterViewer.repaint();

				// XN[Ԃ̒߁B
				// Ȃ}EXNbNĂƁA
				// 񂾂XN[̑҂ԂZȂĂB
				adjustWait += 100;
				if (scrollWait - 100 < adjustWait) {
					adjustWait = scrollWait - 100;
				}

				try {
					this.sleep(scrollWait - adjustWait);
				} catch (Exception e) {}
			}
		}

		void setQuarterViewer(QuarterViewer qv) {
			quarterViewer = qv;
		}
		synchronized void notifyScroll() {
			notifyAll();
		}
		synchronized void waitScroll() {
			try {
				this.wait();
			} catch (Exception e) {}
		}
	}


	public QuarterViewer(Board board) {
		super();

		setSize(quarterViewScreenWidth, quarterViewScreenHeight);
		setBackground(Color.white);

		this.board = board;

		direction = new Direction(Direction.UP_LEFT);
		unitGraphicsEngine = UnitGraphicsEngineApplicationQuarter.getInstance();
		controller = UnitControllerApplicationQuarter.getInstance();
		scrollThread = new ScrollThread();

		init();
		board.addUnitListener(this);
	}


	public int getCenterX() { return centerX; }
	public int getCenterY() { return centerY; }
	public Ground getCenterGround() { return board.getGround(centerX, centerY); }

	public int getCurrentX() { return currentX; }
	public int getCurrentY() { return currentY; }
	public Ground getCurrentGround() { return board.getGround(currentX, currentY); }

	public void setInformationViewer(StrategyWindowInformation infoViewer) {
		this.infoViewer = infoViewer;
	}

	public void init() {

		addMouseListener(this);
		addMouseMotionListener(this);
	}


	public void setBoard(Board board) { this.board = board; }
	public Board getBoard() { return board; }

	public void leftRotateBoard() {
		direction.rightNinetyTurn();
		repaint();
	}
	public void rightRotateBoard() {
		direction.leftNinetyTurn();
		repaint();
	}

	public void paintComponent(Graphics g) {

		quarterViewScreenWidth = getWidth();
		quarterViewScreenHeight = getHeight();

		// ʂ𔒂łʂԂB
		g.setColor(Color.white);
		g.fillRect(0, 0,quarterViewScreenWidth, quarterViewScreenHeight);

		int squareNumberX = ( (quarterViewScreenWidth / squareWidth) | 1 ) + 3;
		int squareNumberY = ( (quarterViewScreenHeight / squareHeight) | 1 ) + 3;

		// \ʏɂԍ̃XNEFA̍W߂B
		int squareX = centerX + ( squareNumberX / 2 * direction.getNextX(Direction.LEFT) ) +
					( squareNumberY / 2 * direction.getNextX(Direction.UP) );
		int squareY = centerY + ( squareNumberX / 2 * direction.getNextY(Direction.LEFT) ) +
					( squareNumberY / 2 * direction.getNextY(Direction.UP) );

		// \ʏ̍W߂B
		// ̍W0,0́AsquareX=0,squareY=0̒SWɂȂB
		int viewerX = ( quarterViewScreenWidth / 2 ) -  ( squareNumberX * squareWidth / 2 );
		int viewerY = ( quarterViewScreenHeight / 2 ) -  ( squareNumberY * squareHeight / 2 );

		for (int y = 0; y < squareNumberY; y++) {
			for (int x = 0; x < squareNumberX; x++) {
				Ground ground = board.getGround(
					squareX + x * direction.getNextX(Direction.RIGHT) +
					y * direction.getNextX(Direction.DOWN),
					squareY + x * direction.getNextY(Direction.RIGHT) +
					y * direction.getNextY(Direction.DOWN) );

				if ( ground != null ) {
					ground.show(g, viewerX + (x * squareWidth),
						viewerY + (y * squareHeight), unitGraphicsEngine, this, direction);
				}
			}
			for (int x = 0; x < squareNumberX; x++) {
				Ground ground = board.getGround(
					squareX + x * direction.getNextX(Direction.RIGHT) +
					y * direction.getNextX(Direction.DOWN) + direction.getNextX(Direction.DOWN_LEFT),
					squareY + x * direction.getNextY(Direction.RIGHT) +
					y * direction.getNextY(Direction.DOWN)  + direction.getNextY(Direction.DOWN_LEFT) );

				if (ground != null) {
					ground.show(g, viewerX + ( x * squareWidth ) - ( squareWidth / 2 ),
						viewerY + ( y * squareHeight ) + ( squareHeight / 2 ),
						unitGraphicsEngine, this, direction);
				}
			}
		}
	}


	public void destroy() {

		removeMouseListener(this);
		removeMouseMotionListener(this);

	}

	/** i|IL݂Ȃɂĕ̕Ȃǂ\邽߂ɂĂ\bhłƂB*/
	public int calcGage(int src, int max, int length) {
		int retGage = src / (max / length);

		if ( 0 >= retGage && 0 < src)
			retGage = 1;
		if ( length < retGage )
			retGage = length;
		return retGage;
	}

	public void mouseDragged(MouseEvent e) {
		mouseX = e.getX();
		mouseY = e.getY();

		if (scrollRange > mouseX || getWidth()-scrollRange < mouseX ||
			scrollRange > mouseY || getHeight()- scrollRange < mouseY) {

			setCursor(new Cursor(Cursor.MOVE_CURSOR));
		} else {
			setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			scrollThread.scrollCondition = false;
		}
	}

	public void mouseMoved(MouseEvent e) {

		mouseX = e.getX();
		mouseY = e.getY();

		if (scrollRange > mouseX || getWidth()-scrollRange < mouseX ||
			scrollRange > mouseY || getHeight()- scrollRange < mouseY) {

			setCursor(new Cursor(Cursor.MOVE_CURSOR));
		} else {
			setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			scrollThread.scrollCondition = false;
		}

		quarterViewScreenWidth = getWidth();
		quarterViewScreenHeight = getHeight();

		int squareNumberX = ( (quarterViewScreenWidth / squareWidth) | 1 ) + 3;
		int squareNumberY = ( (quarterViewScreenHeight / squareHeight) | 1 ) + 3;

		int viewerY = (quarterViewScreenHeight / 2) -
						(squareNumberY * squareHeight / 2);

		int x;
		int x1;
		int x2;
		int directionRL;

		int viewerRigLefX = e.getX() - (quarterViewScreenWidth / 2);
		if (0 <= viewerRigLefX) {
			x = viewerRigLefX / (squareWidth / 2);
			x1 = viewerRigLefX % (squareWidth / 2);

			if ( (x & 1) == 0 ) {
				x2 = x1 - (squareWidth / 2);
				directionRL = Direction.DOWN_RIGHT;
			} else {
				x2 = x1;
				x1 = x2 - (squareWidth / 2);
				directionRL = Direction.DOWN_LEFT;
			}

			x++;
			x = x / 2;
		} else {
			x = viewerRigLefX / ( squareWidth / 2 );
			x1 = viewerRigLefX % ( squareWidth / 2 );

			if ( (x & 1) == 0 ) {
				x2 = (squareWidth / 2) + x1;
				directionRL = Direction.DOWN_LEFT;
			} else {
				x2 = x1;
				x1 = (squareWidth / 2) + x2;
				directionRL = Direction.DOWN_RIGHT;
			}

			x--;
			x = x / 2;
		}

		int roopSuqX = centerX + x * direction.getNextX(Direction.RIGHT) +
		(squareNumberY/2 - 1) * direction.getNextX(Direction.DOWN);

		int roopSuqY = centerY + x * direction.getNextY(Direction.RIGHT) +
		(squareNumberY/2 - 1) * direction.getNextY(Direction.DOWN);

		for (int y = squareNumberY-1; y >= 0; y--) {
			Ground ground = board.getGround( roopSuqX + direction.getNextX(directionRL),
							 roopSuqY + direction.getNextY(directionRL) );

			if (ground != null) {
				if ( ground.contains(x2,
					e.getY() - (viewerY + ( y * squareHeight ) + ( squareHeight)),
					unitGraphicsEngine) ) {
					currentX = roopSuqX + direction.getNextX(directionRL);
					currentY = roopSuqY + direction.getNextY(directionRL);
					break;
				}
			}

			ground = board.getGround(roopSuqX, roopSuqY);

			if (ground != null) {
				if (ground.contains(x1,
					e.getY() - (viewerY +  y * squareHeight + ( squareHeight / 2 )), unitGraphicsEngine)) {
					currentX = roopSuqX;
					currentY = roopSuqY;
					break;
				}
			}
			roopSuqX = roopSuqX + direction.getNextX(Direction.UP);
			roopSuqY = roopSuqY + direction.getNextY(Direction.UP);
		}
		infoViewer.updateData();
	}

	public void mouseReleased(MouseEvent e) {
		scrollThread.scrollCondition = false;
	}

	public void mousePressed(MouseEvent e) {

		mouseX = e.getX();
		mouseY = e.getY();

		if ( scrollRange > mouseX || getWidth()-scrollRange < mouseX ||
			scrollRange > mouseY || getHeight()- scrollRange < mouseY ) {

			scrollThread.setQuarterViewer(this);
			scrollThread.scrollCondition = true;
			scrollThread.notifyScroll();
		} else {

			scrollThread.scrollCondition = false;

			Ground ground = board.getGround(currentX, currentY);
			if (ground != null) {
				controller.setComponentX(mouseX);
				controller.setComponentY(mouseY);
				controller.setComponent(this);
				ground.clicked(controller);
			}
			infoViewer.updateData();
			repaint();
		}
	}

	public void mouseClicked(MouseEvent e) {
	}

	public void mouseEntered(MouseEvent e) {
	}
	public void mouseExited(MouseEvent e) {
		scrollThread.scrollCondition = false;
	}


	public void stateChanged(UnitEvent unitEvent) {
		if ( contains(unitEvent.getX(), unitEvent.getY()) ) {
			repaint();
			infoViewer.repaint();
		}
	}

	public void moved(UnitEvent unitEvent) {
		if ( contains(unitEvent.getX(), unitEvent.getY()) ||
			 contains(unitEvent.getOldX(), unitEvent.getOldY() ) ) {

			repaint();
			infoViewer.repaint();
		}
	}

	/** Ƃė^ꂽBoard̍WA݂Viewer̕`͈͂ǂB*/
	public boolean containsSquare(int x, int y) {

		quarterViewScreenWidth = getWidth();
		quarterViewScreenHeight = getHeight();

		int squareNumberX = ( (quarterViewScreenWidth / squareWidth) | 1 ) + 3;
		int squareNumberY = ( (quarterViewScreenHeight / squareHeight) | 1 ) + 3;

		int leftTopX, leftTopY, rightTopX, rightTopY, leftBottomX, leftBottomY, rightBottomX, rightBottomY;

		switch (direction.getDirection()) {
			case Direction.UP_LEFT:
				leftTopX = x + (squareNumberY / 2) * direction.getNextX(Direction.UP) +
					(squareNumberX / 2) * direction.getNextX(Direction.LEFT);

				leftTopY = y + (squareNumberY / 2) * direction.getNextY(Direction.UP) +
					(squareNumberX / 2) * direction.getNextY(Direction.LEFT);

				rightTopX = x + (squareNumberY / 2) * direction.getNextX(Direction.UP) +
					(squareNumberX / 2) * direction.getNextX(Direction.RIGHT);

				rightTopY = y + (squareNumberY / 2) * direction.getNextY(Direction.UP) +
					(squareNumberX / 2) * direction.getNextY(Direction.RIGHT);

				rightBottomX = x + (squareNumberY / 2) * direction.getNextX(Direction.DOWN) +
					(squareNumberX / 2) * direction.getNextX(Direction.RIGHT);

				rightBottomY = y + (squareNumberY / 2) * direction.getNextY(Direction.DOWN) +
					(squareNumberX / 2) * direction.getNextY(Direction.RIGHT);

				leftBottomX = x + (squareNumberY / 2) * direction.getNextX(Direction.DOWN) +
					(squareNumberX / 2) * direction.getNextX(Direction.LEFT);

				leftBottomY = y + (squareNumberY / 2) * direction.getNextY(Direction.DOWN) +
					(squareNumberX / 2) * direction.getNextY(Direction.LEFT);

			case Direction.UP_RIGHT:
				rightTopX = x + (squareNumberY / 2) * direction.getNextX(Direction.UP) +
					(squareNumberX / 2) * direction.getNextX(Direction.LEFT);

				rightTopY = y + (squareNumberY / 2) * direction.getNextY(Direction.UP) +
					(squareNumberX / 2) * direction.getNextY(Direction.LEFT);

				rightBottomX = x + (squareNumberY / 2) * direction.getNextX(Direction.UP) +
					(squareNumberX / 2) * direction.getNextX(Direction.RIGHT);

				rightBottomY = y + (squareNumberY / 2) * direction.getNextY(Direction.UP) +
					(squareNumberX / 2) * direction.getNextY(Direction.RIGHT);

				leftBottomX = x + (squareNumberY / 2) * direction.getNextX(Direction.DOWN) +
					(squareNumberX / 2) * direction.getNextX(Direction.RIGHT);

				leftBottomY = y + (squareNumberY / 2) * direction.getNextY(Direction.DOWN) +
					(squareNumberX / 2) * direction.getNextY(Direction.RIGHT);

				leftTopX = x + (squareNumberY / 2) * direction.getNextX(Direction.DOWN) +
					(squareNumberX / 2) * direction.getNextX(Direction.LEFT);

				leftTopY = y + (squareNumberY / 2) * direction.getNextY(Direction.DOWN) +
					(squareNumberX / 2) * direction.getNextY(Direction.LEFT);

			case Direction.DOWN_RIGHT:
				rightBottomX = x + (squareNumberY / 2) * direction.getNextX(Direction.UP) +
					(squareNumberX / 2) * direction.getNextX(Direction.LEFT);

				rightBottomY = y + (squareNumberY / 2) * direction.getNextY(Direction.UP) +
					(squareNumberX / 2) * direction.getNextY(Direction.LEFT);

				leftBottomX = x + (squareNumberY / 2) * direction.getNextX(Direction.UP) +
					(squareNumberX / 2) * direction.getNextX(Direction.RIGHT);

				leftBottomY = y + (squareNumberY / 2) * direction.getNextY(Direction.UP) +
					(squareNumberX / 2) * direction.getNextY(Direction.RIGHT);

				leftTopX = x + (squareNumberY / 2) * direction.getNextX(Direction.DOWN) +
					(squareNumberX / 2) * direction.getNextX(Direction.RIGHT);

				leftTopY = y + (squareNumberY / 2) * direction.getNextY(Direction.DOWN) +
					(squareNumberX / 2) * direction.getNextY(Direction.RIGHT);

				rightTopX = x + (squareNumberY / 2) * direction.getNextX(Direction.DOWN) +
					(squareNumberX / 2) * direction.getNextX(Direction.LEFT);

				rightTopY = y + (squareNumberY / 2) * direction.getNextY(Direction.DOWN) +
					(squareNumberX / 2) * direction.getNextY(Direction.LEFT);

			default:
				leftBottomX = x + (squareNumberY / 2) * direction.getNextX(Direction.UP) +
					(squareNumberX / 2) * direction.getNextX(Direction.LEFT);

				leftBottomY = y + (squareNumberY / 2) * direction.getNextY(Direction.UP) +
					(squareNumberX / 2) * direction.getNextY(Direction.LEFT);

				leftTopX = x + (squareNumberY / 2) * direction.getNextX(Direction.UP) +
					(squareNumberX / 2) * direction.getNextX(Direction.RIGHT);

				leftTopY = y + (squareNumberY / 2) * direction.getNextY(Direction.UP) +
					(squareNumberX / 2) * direction.getNextY(Direction.RIGHT);

				rightTopX = x + (squareNumberY / 2) * direction.getNextX(Direction.DOWN) +
					(squareNumberX / 2) * direction.getNextX(Direction.RIGHT);

				rightTopY = y + (squareNumberY / 2) * direction.getNextY(Direction.DOWN) +
					(squareNumberX / 2) * direction.getNextY(Direction.RIGHT);

				rightBottomX = x + (squareNumberY / 2) * direction.getNextX(Direction.DOWN) +
					(squareNumberX / 2) * direction.getNextX(Direction.LEFT);

				rightBottomY = y + (squareNumberY / 2) * direction.getNextY(Direction.DOWN) +
					(squareNumberX / 2) * direction.getNextY(Direction.LEFT);
		}


		if ( !(leftTopX <= x && x <= rightBottomX) ) {
			return false;
		} else if ( leftBottomX <= rightTopX ) {
			if ( x <= leftBottomX ) {

				if ( x + leftTopY - leftTopX >= y && y >= -x + leftTopY + leftTopX ) {
					return true;
				} else {
					return false;
				}

			} else if ( x <= rightTopX ) {

				if ( x + leftTopY - leftTopX >= y && y >= x + leftBottomY - leftBottomX ) {
					return true;
				} else {
					return false;
				}
			} else {

				if ( -x + rightTopY + rightTopX >= y && y >= x + leftBottomY - leftBottomX ) {
					return true;
				} else {
					return false;
				}
			}
		} else {
			if ( x <= rightTopX ) {

				if ( x + leftTopY - leftTopX >= y && y >= -x + leftTopY + leftTopX ) {
					return true;
				} else {
					return false;
				}

			} else if ( x <= leftBottomX ) {

				if ( -x + rightTopY + rightTopX >= y && y >= -x + leftTopY + leftTopX ) {
					return true;
				} else {
					return false;
				}
			} else {

				if ( -x + rightTopY + rightTopX >= y && y >= x + leftBottomY - leftBottomX ) {
					return true;
				} else {
					return false;
				}
			}
		}
	}
}


class StrategyWindowInformation extends JPanel {

	QuarterViewer quarterViewer;

	JLabel groundLabel;
	JLabel structureLabel;
	JLabel creatureLabel;

	JLabel dimension;


	public StrategyWindowInformation(QuarterViewer quarterViewer) {

		this.quarterViewer = quarterViewer;
		StrategyWindowListener strategyWindowListener =
				new StrategyWindowListener(quarterViewer);

		dimension = new JLabel();
		groundLabel = new JLabel();
		structureLabel = new JLabel();
		creatureLabel = new JLabel();

		updateData();

		setLayout(new FlowLayout());

		JPanel panel = new JPanel();
		panel.setLayout(new GridLayout(3, 1));

		panel.add(groundLabel);
		panel.add(structureLabel);
		panel.add(creatureLabel);

		add(dimension);
		add(panel);


		ClassLoader cl = this.getClass().getClassLoader();
		JButton b = new JButton(new ImageIcon( cl.getResource("resources/map.gif") )) {
			public float getAlignmentY() { return 2; }
		};
		b.setRequestFocusEnabled(false);
		b.setMargin(new Insets(0,0,0,0));

		b.setToolTipText("{[hE]");
		b.addActionListener(strategyWindowListener);
		b.setActionCommand("rightTurnBoard");
		b.setMnemonic(KeyEvent.VK_M);
		add(b);
	}


	/**
	 * `悷ŐV̏Ԃɂ郁\bhB
	 */
	void updateData() {

		Integer dimensionX = new Integer(quarterViewer.getCurrentX());
		Integer dimensionY = new Integer(quarterViewer.getCurrentY());

		dimension.setText("X:" + dimensionX.toString() +
								" Y:" + dimensionY.toString());

		Ground ground = quarterViewer.getCurrentGround();
		if (ground != null) {
			groundLabel.setText(ground.getName());

			Structure structure = ground.getStructure();
			if (structure != null) {
				structureLabel.setText(structure.getName());
			} else {
				structureLabel.setText("");
			}

			Creature creature = ground.getCreature();
			if (creature != null) {
				creatureLabel.setText( creature.getName() );
			} else {
				creatureLabel.setText("");
			}
		} else {
			groundLabel.setText("");
			structureLabel.setText("");
			creatureLabel.setText("");
		}
	}

	public void paintComponent(Graphics g) {
		updateData();
		super.paintComponent(g);
	}
}

