package tk.mtantyukityuki.threeKingdoms.view.swing;

import tk.mtantyukityuki.threeKingdoms.model.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

import java.util.*;

public class TimeViewer extends JPanel implements TimeListener {

	Time time = Time.getInstance();

	JLabel year;
	JLabel month;
	JLabel day;

	public TimeViewer() {

		JSlider speedSlider = new JSlider(0, 1000, (1000 - time.getSpeed()) );
		speedSlider.addChangeListener(new SliderListener());

		JPanel datePanel = new JPanel();
		JPanel timeSliderPanel = new JPanel();
		setLayout(new FlowLayout());
		add(datePanel);
		add(timeSliderPanel);

		datePanel.setLayout(new FlowLayout());
		timeSliderPanel.setLayout(new FlowLayout());

		year = new JLabel( (new Integer(time.getYear())).toString() + "N" );
		month = new JLabel( (new Integer(time.getMonth())).toString() + "" );
		day = new JLabel( (new Integer(time.getDay())).toString() + "" );

		datePanel.add(year);
		datePanel.add(month);
		datePanel.add(day);

		timeSliderPanel.add( new JLabel("x") );
		timeSliderPanel.add( new JLabel("x") );
		timeSliderPanel.add(speedSlider);
		timeSliderPanel.add( new JLabel("") );

		time.addTimeListener(this);
	}

	public void updateData() {
		year.setText( (new Integer(time.getYear())).toString() + "N" );
		month.setText( (new Integer(time.getMonth())).toString() + "" );
		day.setText( (new Integer(time.getDay())).toString() + "" );
	}

	public void paintComponent(Graphics g) {
		updateData();
		super.paintComponent(g);
	}

	/** ViewerĎĂTimeCX^X
	ωƂɂт郁\bhB*/
	public void timeChanged(EventObject event) {
		repaint();
	}


	class SliderListener implements ChangeListener {
		public void stateChanged(ChangeEvent e) {
			JSlider s1 = (JSlider)e.getSource();
			time.setSpeed(1000 - s1.getValue());
		}
	}
}

